import { test, expect, describe } from "vitest";

import { expectSolution } from "../01/main.js";
import part1, { sample, puzzleInput } from "./part1.js";
import part2 from "./part2.js";

describe("part 1", () => {
  test("input", () => {
    expect(sample).toMatchObject({
      AA: {
        exists: ["DD", "II", "BB"],
        flow: 0,
      },
    });
  });
  test("sample", () => {
    expect(part1(sample)).toEqual(1651);
  });
  test("solution", () => {
    const r = part1(puzzleInput);
    expect(r).toBeGreaterThan(707);
    expectSolution(part1(puzzleInput)).toEqual(1871);
  });
});

describe.only("part 2", () => {
  test.skip("sample", () => {
    expect(part2(sample)).toEqual(1707);
  });
  test("solution", () => {
    expectSolution(part2(puzzleInput)).toEqual("TODO");
  });
});
